ad=csvread('output.csv');
adf1=csvread('adf2.csv');
adf2=csvread('adf3.csv');
ad=csvread('ieeematrix.csv');
adf1=csvread('adfieee2.csv');
adf2=csvread('adfieee3.csv');
K=sum(ad);
K1=sum(adf1);
K2=sum(adf2);
%% plt
hold on
figure(1)
plot(K,K1,'ro',K,K2,'b*','LineWidth',8)
% plot(K,K3,'Color','#A2142F','Marker','x','LineStyle','none')
plot([0,max(K)],[0,max(K)],'k--','LineWidth',8)
legend('\alpha =0.1','\alpha=0.2','Location','northwest','FontName','Times New Roman','FontSize',60,'LineWidth',3)
xlabel('The node degree of TN','FontName','Times New Roman','FontSize',60,'LineWidth',4)
ylabel('The node degree of MN','FontName','Times New Roman','FontSize',60,'LineWidth',4)
yticks(0:10:40)
xticks(0:10:40)
set(gca,'FontName','Times New Roman','FontSize',60,'LineWidth',3);
hold off
%% Ϸֲ
TaKv=tabulate(K);
TaKv1=tabulate(K1);
TaKv2=tabulate(K2);
hold on
plot(log10(TaKv1(5:end,1)),log10(TaKv1(5:end,2)/1000),'g--x')
plot(log10(TaKv2(5:end,1)),log10(TaKv2(5:end,2)/1000),'r--p')
plot(log10(TaKv(5:end,1)),log10(TaKv(5:end,2)/1000),'b--o')
legend('\alpha =0.1','\alpha=0.15','\alpha =0')
%%
% ad=csvread('output.csv');%ad matrix
ad=csvread('ieeematrix.csv');%ad matrix
K=sum(ad);%
Kba=sort(K,'descend');
aerfaTop=2*sum(K.^2)/((Kba(1)+Kba(2))*sum(K));
AR=zeros(2,2,9,9,1,1,round(10*aerfaTop));
DR=zeros(2,2,9,9,1,1,round(10*aerfaTop));
% SSEA=zeros(1,1,9,9,11,11,round(10*aerfaTop));
% SSED=zeros(2,1,9,9,11,11,round(10*aerfaTop));
r=1;
RA=csvread('AR.csv');
RD=csvread('DR.csv');
for a=1:3
    for b=1
        for c=1
            for d=1:9
                for e=1:9
                    AR(1:4,1:4,e,d,c,b,a)=RA(1:4,(4*r-3):4*r);
                    DR(1:4,1:4,e,d,c,b,a)=RD(1:4,(4*r-3):4*r);
                    r=r+1;
                end
            end
        end
    end
end
%%
p=[0.1,0.5,0.7];
aerfa=[0,0.1,0.2];
sitaD=0.1:0.1:0.9;
sitaA=0.1:0.1:0.9;
ARp=zeros(2,4);
DRp=zeros(2,4);
dp=zeros(1,4,9,9,length(p),length(aerfa));
ap=zeros(1,4,9,9,length(p),length(aerfa));
dv=zeros(1,1,9,9,length(p),length(aerfa));
av=zeros(1,1,9,9,length(p),length(aerfa));
%% ˫ʲ⡡
for a = 1:length(aerfa)
    for pn=1:length(p)
        for b=1
            for c=1
                for d=1:length(sitaD)
                    for e=1:length(sitaA)
                        k=1;
                        for i=1:2
                            for j=3:4
                                ARp(1:size(AR,1),k)=p(pn).*AR(:,i,e,d,c,b,a)+(1-p(pn)).*AR(:,j,e,d,c,b,a);
                                DRp(1:size(AR,1),k)=p(pn).*DR(:,i,e,d,c,b,a)+(1-p(pn)).*DR(:,j,e,d,c,b,a);
                                k=k+1;
                            end
                        end
                         [dp(1,1:size(DRp),e,d,pn,a),ap(1,1:size(DRp,2),e,d,pn,a),dv(1,1,e,d,pn,a),av(1,1,e,d,pn,a)]=nashsolve2(DRp,ARp);
%                          [dp(1,1:2,e,d,pn,a),ap(1,1:2,e,d,pn,a),dv(1,1,e,d,pn,a),av(1,1,e,d,pn,a)]=nashsolve2(DR(3:4,1:2,e,d,c,b,a),AR(3:4,1:2,e,d,c,b,a));
                    end
                end
            end
        end
    end
end

%% defender nashE
figure(1)
faceco=[0,0.4470,0.7410; 1 0 0 ; 0.8500 0.3250 0.0980;0.4660 0.6740 0.1880];
Q=1;
for a = 1
    for pn=1:length(p)
        lin=zeros(9,9);       
%         subplot(3,3,Q)
        figure(20+Q)
        
        hold on
        for o=1:4
        for i=1:length(sitaA)
            for j=1:length(sitaD)
                lin(i,j)=dp(1,o,i,j,pn,a);
            
            end
        end
        surf(0.1:0.1:0.9,0.1:0.1:0.9,lin,'FaceColor',faceco(o,:),'LineWidth',1.5)
         
        end 
        surf(0.1:0.1:0.9,0.1:0.1:0.9,lin,'FaceColor',[0.93 0.69 0.13],'LineWidth',1.5)
        grid on
%         legend('THD','TLD','MHD','MLD','FontName','Times New Roman','FontSize',20)
        alpha(0.9)
        
%         imagesc(0.1:0.1:0.9,0.1:0.1:0.9,lin)
%         [x,y]=meshgrid(0.1*round(linspace(0,size(lin,1),11))+0.05,0.1*round(linspace(0,size(lin,2),11))+0.05);
%         mesh(y,x,zeros(size(x)),'Facecolor','None','LineWidth',1,'EdgeColor','k')
%         grid on
        title(['\alpha=',num2str(aerfa(a)),',','\omega=',num2str(p(pn))],'FontName','Times New Roman','FontSize',10)
        ylabel('\theta^A','FontName','Times New Roman','FontSize',40)
        xlabel('\theta^D','FontName','Times New Roman','FontSize',40)
%         %
        zlabel('Probability','FontName','Times New Roman','FontSize',40)
        set(gca,'FontName','Times New Roman','FontSize',40,'LineWidth',2);
        view([-1,-2,1])
%         %             xticks(1:5:20)
%         %             yticks(1:4:15)
%         co=colorbar;
%         %             co.Label.String='Probability of HD';
%         caxis([0,1])
        set(gca,'FontName','Times New Roman','FontSize',28,'LineWidth',2);
        %             mesh(lin)
        %             view([0,0,1])
        Q=Q+1;
    end
end
for a = 2:length(aerfa)
    for pn=1:length(p)
        lin=zeros(9,9);       
%         subplot(3,3,Q)
        figure(20+Q)
        hold on
        for o=1:4
        for i=1:length(sitaA)
            for j=1:length(sitaD)
                lin(i,j)=dp(1,o,i,j,pn,a);
            
            end
        end
        surf(0.1:0.1:0.9,0.1:0.1:0.9,lin,'FaceColor',faceco(o,:),'LineWidth',1.5)
        alpha(0.9)
        end
        grid on
        
        legend('THD','TLD','MHD','MLD','FontName','Times New Roman','FontSize',10)
        set(gca,'FontName','Times New Roman','FontSize',40,'LineWidth',2);
%         imagesc(0.1:0.1:0.9,0.1:0.1:0.9,lin)
%         [x,y]=meshgrid(0.1*round(linspace(0,size(lin,1),11))+0.05,0.1*round(linspace(0,size(lin,2),11))+0.05);
%         mesh(y,x,zeros(size(x)),'Facecolor','None','LineWidth',1,'EdgeColor','k')
%         grid on
        title(['\alpha=',num2str(aerfa(a)),',','\omega=',num2str(p(pn))],'FontName','Times New Roman','FontSize',40)
        ylabel('\theta^A','FontName','Times New Roman','FontSize',40)
        xlabel('\theta^D','FontName','Times New Roman','FontSize',40)
%         %
        zlabel('Probability','FontName','Times New Roman','FontSize',40)
        view([-1,-2,1])
%         %             xticks(1:5:20)
%         %             yticks(1:4:15)
%         co=colorbar;
%         %             co.Label.String='Probability of HD';
%         caxis([0,1])
        set(gca,'FontName','Times New Roman','FontSize',28,'LineWidth',2);
        %             mesh(lin)
        %             view([0,0,1])
        Q=Q+1;
    end
end
    
%% H attacker nashE 
figure(2)
Q=1;
for a = 1:length(aerfa)
    for pn=1:length(p)
                    lin=zeros(9,9);
            for i=1:length(sitaA)
                for j=1:length(sitaD)
                    lin(i,j)=ap(1,1,i,j,pn,a)+ap(1,2,i,j,pn,a);
                end
            end
%             subplot(3,3,Q)
            
            figure(20+Q)
            hold on
            imagesc(0.1:0.1:0.9,0.1:0.1:0.9,lin)
            [x,y]=meshgrid(0.1*round(linspace(0,size(lin,1),11))+0.05,0.1*round(linspace(0,size(lin,2),11))+0.05);
            mesh(y,x,zeros(size(x)),'Facecolor','None','LineWidth',1,'EdgeColor','k')
            grid on
            title(['\alpha=',num2str(aerfa(a)),',','\omega=',num2str(p(pn))],'FontName','Times New Roman','FontSize',10)
            ylabel('\theta^A','FontName','Times New Roman','FontSize',40)
            xlabel('\theta^D','FontName','Times New Roman','FontSize',40)
%             
%           zlabel('Probability of HD','FontName','Times New Roman','FontSize',24)
            view([0,0,1])
            %             xticks(1:5:20)
            %             yticks(1:4:15)
            co=colorbar;
              co.Label.String='Probability of THA';
            caxis([0,1])
            set(gca,'FontName','Times New Roman','FontSize',28,'LineWidth',2);
            axis square
            %             mesh(lin)
            %             view([0,0,1])
            Q=Q+1;
    end
end
%% L attacker nashE 
figure(3)
Q=1;
for a = 1:length(aerfa)
    for pn=1:length(p)
                    lin=zeros(9,9);
            for i=1:length(sitaA)
                for j=1:length(sitaD)
                    lin(i,j)=ap(1,1,i,j,pn,a)+ap(1,3,i,j,pn,a);
                end
            end
            figure(30+Q)
            hold on
            imagesc(0.1:0.1:0.9,0.1:0.1:0.9,lin)
             [x,y]=meshgrid(0.1*round(linspace(0,size(lin,1),11))+0.05,0.1*round(linspace(0,size(lin,2),11))+0.05);
            mesh(y,x,zeros(size(x)),'Facecolor','None','LineWidth',1,'EdgeColor','k')
            grid on
             title(['\alpha=',num2str(aerfa(a)),',','\omega=',num2str(p(pn))],'FontName','Times New Roman','FontSize',10)
            ylabel('\theta^A','FontName','Times New Roman','FontSize',40)
            xlabel('\theta^D','FontName','Times New Roman','FontSize',40)
%             
%             zlabel('Probability of HD','FontName','Times New Roman','FontSize',24)
            view([0,0,1])
            %             xticks(1:5:20)
            %             yticks(1:4:15)
            co=colorbar;
           co.Label.String='Probability of MHA';
            caxis([0,1])
            set(gca,'FontName','Times New Roman','FontSize',28,'LineWidth',2);
            axis square
            %             mesh(lin)
            %             view([0,0,1])
            Q=Q+1;
    end
end
%%  
% figure(4)
% Q=1;
% for a = 1:length(aerfa)
%     for pn=1:length(p)
%         
%                     lin=zeros(9,9);
%             for i=1:length(sitaA)
%                 for j=1:length(sitaD)
%                     lin(i,j)=dv(1,1,i,j,pn,a);
%                 end
%             end
%             subplot(3,3,Q)
%             hold on
%             imagesc(0.1:0.1:0.9,0.1:0.1:0.9,lin)
%             [x,y]=meshgrid(0.1*round(linspace(0,size(lin,1),11))+0.05,0.1*round(linspace(0,size(lin,2),11))+0.05);
%             mesh(y,x,zeros(size(x)),'Facecolor','None','LineWidth',1,'EdgeColor','k')
%             grid on
%             title(['\alpha=',num2str(aerfa(a)),',','p=',num2str(p(pn))],'FontName','Times New Roman','FontSize',30)
%             ylabel('\theta^A','FontName','Times New Roman','FontSize',24)
%             xlabel('\theta^D','FontName','Times New Roman','FontSize',24)
% %             
% %             zlabel('Probability of HD','FontName','Times New Roman','FontSize',24)
%             view([0,0,1])
%             %             xticks(1:5:20)
%             %             yticks(1:4:15)
%             co=colorbar;
% %             co.Label.String='Probability of HD';
% %             caxis([-1,0])
%             set(gca,'FontName','Times New Roman','FontSize',18,'LineWidth',2);
%             %             mesh(lin)
%             %             view([0,0,1])
%             Q=Q+1;
%             
%     end
% end
%       set(gca,'FontName','Times New Roman','FontSize',20,'LineWidth',3);
%% 
Q=1;
faceco=[0,0.4470,0.7410; 0.4660 0.6740 0.1880; 0.8500 0.3250 0.0980 ];
figure(5)

%     for b=1:4:length(qD)
%         for c=b
        for a = 1:3%length(aerfa):-1:1
            lin=zeros(9,9);
            for i=1:length(sitaA)
                for j=1:length(sitaD)
                    lin(i,j)=dv(1,1,i,j,2,a);
                end
            end
%             figure(40+Q)
            
            hold on
            %             lin(9,:)=zeros(1,9);
            surf([0.1:0.1:0.9],[0.1:0.1:0.9],lin,'FaceColor',faceco(a,:),'LineWidth',2)
%             title(['\beta=',num2str(qD(d))],'FontName','Times New Roman','FontSize',30)
%             ylabel('\theta^A','FontName','Times New Roman','FontSize',40)
%             xlabel('\theta^D','FontName','Times New Roman','FontSize',40)
%             zlabel('Payoff ','FontName','Times New Roman','FontSize',40)
            zticks(-1:0.2:0)
            
            %             zticks([0:0.5:1])
            %             colorbar
%             caxis([0,1])
            %             mesh(lin)
            view([-1.5,-0.6,0.3])
            set(gca,'FontName','Times New Roman','FontSize',60,'LineWidth',2);
            legend(['\alpha=',num2str(aerfa(1))],['\alpha=',num2str(aerfa(2))],['\alpha=',num2str(aerfa(3))],'Location','southeast')
            grid on
            axis equal
        end
        title('MD & TA','FontName','Times New Roman','FontSize',60)
  zlabel('Payoff','FontName','Times New Roman','FontSize',60)
  ylabel('\theta^A','FontName','Times New Roman','FontSize',60)
  xlabel('\theta^D','FontName','Times New Roman','FontSize',60)
  %% 

%% 
Q=1;
faceco=[0,0.4470,0.7410; 0.4660 0.6740 0.1880; 0.8500 0.3250 0.0980 ];
figure(5)

%     for b=1:4:length(qD)
%         for c=b
for pn=1:3
        for a = 1:3%length(aerfa):-1:1
            lin=zeros(9,9);
            for i=1:length(sitaA)
                for j=1:length(sitaD)
                    lin(i,j)=dv(1,1,i,j,pn,a);
                end
            end
%             figure(40+Q)
            
            subplot(1,3,Q)
            hold on
            %             lin(9,:)=zeros(1,9);
            surf([0.1:0.1:0.9],[0.1:0.1:0.9],lin,'FaceColor',faceco(a,:),'LineWidth',2)
%             title(['\beta=',num2str(qD(d))],'FontName','Times New Roman','FontSize',30)
            ylabel('\theta^A','FontName','Times New Roman','FontSize',45)
            xlabel('\theta^D','FontName','Times New Roman','FontSize',45)
            zlabel('Payoff ','FontName','Times New Roman','FontSize',45)
            
            %             zticks([0:0.5:1])
            %             colorbar
%             caxis([0,1])
            %             mesh(lin)
            view([-1.5,-0.6,0.3])
            set(gca,'FontName','Times New Roman','FontSize',50,'LineWidth',2);
            legend(['\alpha=',num2str(aerfa(1))],['\alpha=',num2str(aerfa(2))],['\alpha=',num2str(aerfa(3))],'Location','east')
            grid on
            axis equal
        end
        Q=Q+1; 
        title(['\omega=',num2str(p(pn))],'FontName','Times New Roman','FontSize',50)
end
%   zlabel('Payoff','FontName','Times New Roman','FontSize',30)
%   ylabel('\theta^A','FontName','Times New Roman','FontSize',30)
%   xlabel('\theta^D','FontName','Times New Roman','FontSize',30)
           

%% thetaA=thetaD Ƕ
% H
pt=zeros(9,3);
figure(6)
for a=1:length(aerfa)
    for i=1:9
        pt(i,a)=DR(3,1,i,i,1,1,a);
    end
end
hold on
plot(0.1:0.1:0.9,pt(:,1),'-o','Color',[0.6350 0.0780 0.1840],'LineWidth',1.5)
plot(0.1:0.1:0.9,pt(:,2),'-d','Color',[0 0.4470 0.7410],'LineWidth',1.5)
plot(0.1:0.1:0.9,pt(:,3),'-h','Color',[0.9290 0.6940 0.1250],'LineWidth',1.5)
legend('\alpha = 0','\alpha=0.1','\alpha=0.2','FontName','Times New Roman','FontSize',20)
title(['THA','&','MHD'],'FontName','Times New Roman','FontSize',20)
xlabel('\theta','FontName','Times New Roman','FontSize',20)
ylabel('u^D(THA,MHD)','FontName','Times New Roman','FontSize',20)
xticks(0:0.2:1)
yticks(-0.8:0.2:0)
set(gca,'FontName','Times New Roman','FontSize',20,'LineWidth',1.5);

% L
pt=zeros(9,3);
figure(7)
for a=1:length(aerfa)
    for i=1:9
        pt(i,a)=DR(4,2,i,i,1,1,a);
    end
end 
hold on
plot(0.1:0.1:0.9,pt(:,1),'-o','Color',[0.6350 0.0780 0.1840],'LineWidth',1.5)
plot(0.1:0.1:0.9,pt(:,2),'-d','Color',[0 0.4470 0.7410],'LineWidth',1.5)
plot(0.1:0.1:0.9,pt(:,3),'-h','Color',[0.9290 0.6940 0.1250],'LineWidth',1.5)
legend('\alpha = 0','\alpha=0.1','\alpha=0.2','FontName','Times New Roman','FontSize',20)
title(['TLA','&','MLD'],'FontName','Times New Roman','FontSize',20)
xlabel('\theta','FontName','Times New Roman','FontSize',20)
ylabel('u^D(TLA,MLD)','FontName','Times New Roman','FontSize',20)
xticks(0:0.2:1)
yticks(-0.6:0.2:0)
set(gca,'FontName','Times New Roman','FontSize',20,'LineWidth',1.5);


%% figure(4)
ARq=zeros(4,4,9,9,3,3);
DRq=zeros(4,4,9,9,3,3);
dvf=zeros(1,1,9,9,length(p),length(aerfa));
for a = 1:length(aerfa)
    for pn=1:length(p)
        for b=1
            for c=1
                for d=1:length(sitaD)
                    for e=1:length(sitaA)
                        k=1;
                        for i=1:2
                            for j=3:4
                                ARq(1:size(AR,1),k,e,d,pn,a)=p(pn).*AR(:,i,e,d,c,b,a)+(1-p(pn)).*AR(:,j,e,d,c,b,a);
                                DRq(1:size(AR,1),k,e,d,pn,a)=p(pn).*DR(:,i,e,d,c,b,a)+(1-p(pn)).*DR(:,j,e,d,c,b,a);
                                k=k+1;
                            end
                        end
                    end
                end
            end
        end
    end
end
for a=1:length(aerfa)
    for i=1:length(sitaD)
        for j=1:length(sitaA)
            dvf(1,1,j,i,1,a)=dp(:,:,j,i,3,a)*DRq(:,:,j,i,1,a)*ap(:,:,j,i,3,a)';
        end
    end
    
end
for a=1:length(aerfa)
    for i=1:length(sitaD)
        for j=1:length(sitaA)
            dvf(1,1,j,i,3,a)=dp(:,:,j,i,1,a)*DRq(:,:,j,i,3,a)*ap(:,:,j,i,1,a)';
        end
    end
    
end
%% лͼ
faceco=[0,0.4470,0.7410; 0.4660 0.6740 0.1880; 0.8500 0.3250 0.0980 ];
%     for b=1:4:length(qD)
%         for c=b
for pn=1:2:3
    Q=1;
    
     figure(pn*10)
    for a = 2:3%length(aerfa):-1:1
      
        lin=zeros(9,9);
        lin1=zeros(9,9);
        for i=1:length(sitaA)
            for j=1:length(sitaD)
                lin(i,j)=dv(1,1,i,j,pn,a);
                lin1(i,j)=dvf(1,1,i,j,pn,a);
            end
        end
        %          figure(40+Q)
        subplot(1,2,Q)
        hold on
        %             lin(9,:)=zeros(1,9);
        surf([0.1:0.1:0.9],[0.1:0.1:0.9],lin,'FaceColor',[0.6350 0.0780 0.1840],'LineWidth',2)
        surf([0.1:0.1:0.9],[0.1:0.1:0.9],lin1,'FaceColor',[0.9290 0.6940 0.1250],'LineWidth',2)
        surf([0.1:0.1:0.9],[0.1:0.1:0.9],lin-lin1,'FaceColor',[0.3010 0.7450 0.9330],'LineWidth',2)
        title(['\alpha=',num2str(aerfa(a)),',','\Omega=(',num2str(p(pn)),',',num2str(1-p(pn)),') ,','\Omega''=(',num2str(p(4-pn)),',',num2str(1-p(4-pn)),')'],'FontName','Times New Roman','FontSize',40)
        ylabel('\theta^A','FontName','Times New Roman','FontSize',40)
        xlabel('\theta^D','FontName','Times New Roman','FontSize',40)
        zlabel('Payoff ','FontName','Times New Roman','FontSize',40)
        grid on
        zlim([-1 0.35])
%         xticks([0:0.5:1])
% %         yticks([0:0.5:1])
%         zticks([-1:0.3:1])
         
        %             colorbar
        %             caxis([0,1])
        %             mesh(lin)
        view([-1.5,-0.6,0.2])
         axis square
        set(gca,'FontName','Times New Roman','FontSize',40,'LineWidth',2);
        legend('Correct','Incorrect','\delta (C-I)','Location','southeast')
        Q=Q+1;
        
    end
end 




